header {* Quick introduction to ML, session 3 *}

theory ML3_Combinators imports Isac begin

text{* This course follows the book:
J.D.Ullmann, Elements of ML Programming. Prenctice Hall 1998.
Contents:*}

section {* 5.6 Higher-Order Functions *}

subsection {* map *}ML {*
map;
fun add3 a = a + 3: int;
map add3 [];
map add3 [1,2,3,4,5];
*}
ML {*
fun greater a b = a > b;
greater 2 3;
greater 5 3;
greater 5;
map (greater 3) [1,2,3,4,5];
*}

subsection {* fold *}
ML {*
fold;
fun add a b = a + b;
fun mult a b = a * b;
*}
ML {*
fold add [1,2,3,4,5] 10;
fold add [1,2,3,4,5] 10;

fold mult [1,2,3] 1;
fold mult [1,2,3,4,5] 1;
*}

section {* Bad style: local variables in functions *}
ML {*
fun xxx a b c d e f =
  let 
    val x = a + b
    val _ = writeln ("### xxx: x = " ^ string_of_int x)
    val y = c * d
    val z = e ^ f
  in (x, y , z) end;
xxx 1 2 3 4  "a" "b";
*}
text {* little improvement *}
ML {*
fun xxx a b c d e f =
  let 
    val x = a + b
    val _ = writeln (string_of_int x)
    val _ = string_of_int x |> writeln
    val y = c * d
    val z = e ^ f
  in (x, y , z) end;
xxx 1 2 3 4  "a" "b";
*}


section {* Combinators, see src/Pure/General/basics.ML *}
subsection {* Preliminaries *}
ML {*
(*infix +++;*)
fun +++ a b = a + b;
+++ 1 3;
*}
ML {*
fn x => x + 10; (* function without a name*)
(fn x => x + 10) 3;

fun ??? x = x + 10;
*}

subsection {* Combinators with example in test/Pure/General/Basics.thy *}
ML {*
op |> 
*}
ML {*
op ||> ;
*}

subsection {* Still no examples in test/Pure/General/Basics.thy *}
text {* please, find examples for ||>> ff ! *}
ML {*
op #>>;
fun fff a = (a + 10, string_of_int a);
fun ggg b = b * 2;
fff #>> ggg;
(fff #>> ggg) 1;
*}

end
